#
# spec file for package audiofile
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define so_num 1

Name:           audiofile
Version:        0.3.6
Release:        11.28
Summary:        An Audio File Library
License:        GPL-2.0-or-later AND LGPL-2.1-or-later
Group:          System/Libraries
%define lname	libaudiofile%{so_num}
Url:            http://www.68k.org/~michael/audiofile/
Source:         http://download.gnome.org/sources/audiofile/0.3/%{name}-%{version}.tar.xz
Source2:        baselibs.conf
# PATCH-FIX-SECURITY audiofile-CVE-2015-7747.patch bsc949399 CVE-2015-7747 sbrabec@suse.com -- Fix overflow when changing both number of channels and sample format https://github.com/mpruett/audiofile/pull/25/files https://github.com/mpruett/audiofile/pull/25.patch
Patch:          audiofile-CVE-2015-7747.patch
Patch2:         audiofile-gcc6.patch
# PATCH-FIX-UPSTREAM 0001-Always-check-the-number-of-coefficients.patch boo#1026978 alarrosa@suse.com -- Check number of coefficients https://github.com/mpruett/audiofile/pull/42
Patch3:         0001-Always-check-the-number-of-coefficients.patch
# PATCH-FIX-UPSTREAM 0002-Check-for-multiplication-overflow-in-MSADPCM-decodeS.patch boo#1026978 alarrosa@suse.com -- Check for multiplication overflow in MSADPCM.cpp https://github.com/mpruett/audiofile/pull/42
Patch4:         0002-Check-for-multiplication-overflow-in-MSADPCM-decodeS.patch
# PATCH-FIX-UPSTREAM 0003-Check-for-multiplication-overflow-in-sfconvert.patch boo#1026978 alarrosa@suse.com -- Check for multiplication overflow in sfconvert https://github.com/mpruett/audiofile/pull/42
Patch5:         0003-Check-for-multiplication-overflow-in-sfconvert.patch
# PATCH-FIX-UPSTREAM 0004-clamp-index-values-to-fix-index-overflow-in-IMA.cpp.patch boo#1026981 alarrosa@suse.com -- Clamp index values to fix index overflow https://github.com/mpruett/audiofile/pull/43
Patch6:         0004-clamp-index-values-to-fix-index-overflow-in-IMA.cpp.patch
# PATCH-FIX-UPSTREAM 0005-Actually-fail-when-error-occurs-in-parseFormat.patch boo#1026983 alarrosa@suse.com -- Actually fail when error occurs in parseFormat https://github.com/mpruett/audiofile/pull/44
Patch7:         0005-Actually-fail-when-error-occurs-in-parseFormat.patch
# PATCH-FIX-UPSTREAM 0006-Check-for-division-by-zero-in-BlockCodec-runPull.patch boo#1026983 alarrosa@suse.com -- Check for division by zero in BlockCodec::runPull https://github.com/mpruett/audiofile/pull/44
Patch8:         0006-Check-for-division-by-zero-in-BlockCodec-runPull.patch
# PATCH-FIX-UPSTREAM 0007-set-the-output-chunk-to-the-amount-of-frames.patch boo#11115865 qzheng@suse.com -- Set output chunk framecount after pull https://github.com/mpruett/audiofile/pull/52
Patch9:         0007-set-the-output-chunk-to-the-amount-of-frames.patch
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc-c++
BuildRequires:  libtool
BuildRequires:  pkg-config
BuildRequires:  xz
%if 0%{?sles_version}
BuildRequires:  flac-devel >= 1.2.1
%else
BuildRequires:  pkgconfig(flac) >= 1.2.1
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This audio file library is an implementation of the SGI audio file
library. At present, not all features of the SGI audio file library are
implemented.

This library allows the processing of audio data to and from audio
files of many common formats (currently AIFF, AIFC, WAVE, and
NeXT/Sun).

%package -n %lname
Summary:        An Audio File Library
Group:          System/Libraries

%description -n %lname
This audio file library is an implementation of the SGI audio file
library. At present, not all features of the SGI audio file library are
implemented.

This library allows the processing of audio data to and from audio
files of many common formats (currently AIFF, AIFC, WAVE, and
NeXT/Sun).

%package devel
Summary:        An audio file library
Group:          Development/Libraries/C and C++
Requires:       %lname = %{version}

%description devel
This Audio File Library is an implementation of the SGI Audio File
library. At present, not all features of the SGI Audio File library are
implemented.

This library allows the processing of audio data to and from audio
files of many common formats (currently AIFF, AIFC, WAVE, and
NeXT/Sun).

%package doc
Summary:        An audio file library
Group:          Documentation/Man
Requires:       %{name} = %{version}

%description doc
This Audio File Library is an implementation of the SGI Audio File
library. At present, not all features of the SGI Audio File library are
implemented.

This library allows the processing of audio data to and from audio
files of many common formats (currently AIFF, AIFC, WAVE, and
NeXT/Sun).

%prep
%setup -q
%patch -p1
%patch2
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1

%build
autoreconf -fi
%configure --disable-examples
make %{?_smp_mflags}
cp -a docs install_docs
rm install_docs/Makefile*

%install
make DESTDIR=$RPM_BUILD_ROOT install
rm %{buildroot}/%{_libdir}/*.la
# The static library is needed for "UnitTests" (from make check) to build
rm %{buildroot}/%{_libdir}/*.a

%check
make check %{?_smp_mflags}

%post -n %lname -p /sbin/ldconfig

%postun -n %lname -p /sbin/ldconfig

%files
%defattr(-, root, root)
%doc README TODO COPYING* ACKNOWLEDGEMENTS AUTHORS NEWS NOTES
%{_bindir}/sfconvert
%{_bindir}/sfinfo
%{_mandir}/man1/sfconvert.1*
%{_mandir}/man1/sfinfo.1*

%files -n %lname
%defattr(-,root,root)
%{_libdir}/libaudiofile.so.%{so_num}*

%files devel
%defattr(-, root, root)
%{_includedir}/*
%{_libdir}/libaudiofile.so
%{_libdir}/pkgconfig/audiofile.pc

%files doc
%defattr(-, root, root)
%{_mandir}/man3/af*.3*

%changelog
* Thu Oct 18 2018 qzheng@suse.com
- Add 0007-set-the-output-chunk-to-the-amount-of-frames.patch to
  set the output chunk to the amount of frames we pulled so that
  the next module in the chain has the correct frame count (
  boo#1111586, CVE-2018-17095 ).
* Thu Mar  9 2017 alarrosa@suse.com
- Add 0001-Always-check-the-number-of-coefficients.patch to put in code
  an assert that was removed when building the code for a release
  which checks the number of coeficients in WAVE.cpp .
- Add 0002-Check-for-multiplication-overflow-in-MSADPCM-decodeS.patch
  to check for a multiplication overflow in MSADPCM.cpp .
- Add 0003-Check-for-multiplication-overflow-in-sfconvert.patch to
  check that a multiplication doesn't overflow when calculating a
  buffer size and reduce it if necessary.
- Add 0004-clamp-index-values-to-fix-index-overflow-in-IMA.cpp.patch
  to clamp index values to fix an index overflow in IMA.cpp .
- Add 0005-Actually-fail-when-error-occurs-in-parseFormat.patch
  so when there's an unsupported number of bits per sample or an invalid
  number of samples per block, don't only print an error message using
  the error handler, but actually stop parsing the file.
- Add 0006-Check-for-division-by-zero-in-BlockCodec-runPull.patch to
  check for division by zero in BlockCodec::runPull
- These patches fix boo#1026978 (CVE-2017-6837, CVE-2017-6838,
  CVE-2017-6839), boo#1026979 (CVE-2017-6827),
  boo#1026980 (CVE-2017-6828), boo#1026981 (CVE-2017-6829),
  boo#1026982 (CVE-2017-6830), boo#1026983 (CVE-2017-6831),
  boo#1026984 (CVE-2017-6832), boo#1026985 (CVE-2017-6833),
  boo#1026986 (CVE-2017-6834), boo#1026987 (CVE-2017-6836),
  boo#1026988 (CVE-2017-6835).
* Fri Jan 29 2016 rguenther@suse.com
- Add audiofile-gcc6.patch to fix compile errors with GCC 6.
* Thu Oct 22 2015 sbrabec@suse.com
- Fix overflow when changing both number of channels and sample
  format (bsc#949399, CVE-2015-7747,
  audiofile-CVE-2015-7747.patch).
* Thu Aug 14 2014 fcrozat@suse.com
- Add Obsoletes audiofiles-32bit to baselibs.conf
* Tue Mar 25 2014 avvissu@yandex.ru
- Fix unresolvable dependencies for SLE11:
  + add RPM conditional tests for sles_version
- Fix compilation error on SLE11: permission denied:
  + add $DESTDIR to make install
* Thu Mar  7 2013 reddwarf@opensuse.org
- Update to version 0.3.6:
  + Implement FLAC and ALAC encoding and decoding.
  + Update license to LGPL 2.1.
- Remove audiofile-0.3.5-without_examples.patch
- Add pkgconfig(flac) BuildRequires
* Wed Feb 20 2013 reddwarf@opensuse.org
- Update to version 0.3.5:
  + Implement IMA ADPCM encoding and decoding for AIFF-C, CAF, and WAVE files.
  + Implement Microsoft ADPCM encoding for WAVE files.
  + Fix calculation of IRCAM frame size.
  + Record marker comments in WAVE files.
  + Improve validation of compressed audio formats.
  + Add support for building without documentation.
- Add audiofile-0.3.5-without_examples.patch
- Remove audiofile-remove-unused-variables.patch
- Remove Obsoletes: audiofile-64bit
* Fri Feb  1 2013 coolo@suse.com
- update license to new format
* Fri May 11 2012 vuntz@opensuse.org
- Update to version 0.3.4:
  + Use hidden visibility for internal symbols.
  + Add support for Sample Vision format.
  + Update license for extended-precision floating-point conversion
    routines.
* Tue Jan 17 2012 vuntz@opensuse.org
- Update to version 0.3.3:
  + Update library's soname version.
  + Link against libm.
- Drop audiofile-add-lm-linker.patch: fixed upstream.
- Rebase audiofile-remove-unused-variables.patch.
- Remove call to autoreconf: it was only there for
  audiofile-add-lm-linker.patch.
- Move man pages from libaudiofile0 subpackage to audiofile
  subpackage, where the binaries live.
- Rename libaudiofile0 subpackage to libaudiofile1, following
  upstream soversion change.
* Wed Nov 30 2011 dimstar@opensuse.org
- Update to version 0.3.2:
  + Fix initialization of byte order in Creative Voice File format.
  + Fix calculation of frame count in NIST SPHERE sound files.
  + Remove duplicate definition of AFvirtualfile.
  + Don't treat compiler warnings as errors by default.
- Clean spec file using spec-cleaner.
- Add xz BuildRequires because we can't build a package for a
  xz-compressed tarball without explicitly specifying that... See
  bnc#697467 for more details.
* Fri Sep 30 2011 coolo@suse.com
- add libtool as buildrequire to make the spec file more reliable
* Tue Sep 20 2011 jengelh@medozas.de
- Remove redundant tags/sections from specfile
- Fix a typo in %%_smp_mflags
- Implement shlib policy
* Mon Sep 19 2011 appleonkel@opensuse.org
- Update to version 0.3.1:
  + Support u-law and A-law compression in Core Audio Format files
  + Add support for Creative Voice File format
  + Define AFframecount and AFfileoffset as 64-bit signed integers
  + Add support for extensible WAVE format
- Added audiofile-remove-unused-variables.patch for -Werror
- Added audiofile-add-lm-linker.patch to fix build error
- Drop audiofile-oldstyle.patch, fixed by upstream in a different way.
- Split documentation of the library into doc package
- Removed Obsoletes/Provides audiofil, seems outdated
* Mon May 10 2010 dimstar@opensuse.org
- Update to version 0.2.7:
  + Fix decoding of multi-channel ADPCM WAVE files.
  + Reduce unshared data in library.
  + Fix handling of audio files with more than 2^24 frames.
  + Add support for writing double-precision floating-point WAVE
    files.
  + Add support for reading certain uncompressed AIFF-C files
    created by Mac OS X.
  + Write fact chunk in floating-point WAVE files.
- Drop bnc_463220.patch, fixed by upstream in a different way.
- Drop audiofile-0.2.6.patch, audiofile-m4_quote_fix.diff and
  audiofile-fiximplicit.patch.
* Sat Apr 24 2010 coolo@novell.com
- buildrequire pkg-config to fix provides
* Thu Dec 17 2009 jengelh@medozas.de
- add baselibs.conf as a source
* Tue Oct 27 2009 meissner@suse.de
- fixed implicit functions
* Sun Feb 22 2009 mboman@suse.de
- Don't use -fno-strict-aliasing for build. Not needed
- Remove CFLAGS, CXXFLAGS and FFLAGS since it only contains
  $RPM_OPT_FLAGS which is default
* Tue Jan 20 2009 mauro@suse.de
- Added bnc_463220.patch to fix bnc#463220
  + Correct buffer size.
* Tue Jan 20 2009 msuman@suse.de
- Clean up the spec file to use proper RPM macros
- Continue to provide the "la" files for SUSE releases <= 11.1
* Tue Jan 13 2009 crrodriguez@suse.de
- remove static libraries and "la" files
- run make check
* Wed Dec 10 2008 olh@suse.de
- use Obsoletes: -XXbit only for ppc64 to help solver during distupgrade
  (bnc#437293)
* Thu Oct 30 2008 olh@suse.de
- obsolete old -XXbit packages (bnc#437293)
* Thu Apr 10 2008 ro@suse.de
- added baselibs.conf file to build xxbit packages
  for multilib support
* Wed Sep  6 2006 anosek@suse.cz
- fixed warning: old-style function definition
  [#203121] (oldstyle.patch)
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Sep 16 2005 meissner@suse.de
- fixed some implicits.
* Mon Apr 11 2005 sbrabec@suse.cz
- Splitted devel subpackage (#59204).
* Mon Nov 22 2004 gekker@suse.de
- Update to version 0.2.6
* Wed Aug 25 2004 kukuk@suse.de
- Avoid /bin/sh as PreRequires
* Mon Apr 19 2004 ro@suse.de
- fix "control reaches end of non-void function" warnings
* Thu Mar 18 2004 sbrabec@suse.cz
- Do not package makefiles to documentation (#36305).
* Thu Feb 19 2004 sbrabec@suse.cz
- Updated to version 0.2.5.
* Fri Jan 16 2004 pth@suse.de
- Fix quoting in audiofile.m4
* Sat Jan 10 2004 adrian@suse.de
- add %%run_ldconfig
* Sat Jul 27 2002 kukuk@suse.de
- Provide audiofile-devel [Bug #17262]
* Wed Feb  6 2002 coolo@suse.de
- use %%_libdir
* Sat Feb  2 2002 adrian@suse.de
- add libaudiofile.so and libaudiofile.la to file list
  (this makes the -fPIC obsolete and arts can play again .way :)
* Sun Jan 27 2002 schwab@suse.de
- Build with -fPIC so that it can be included in a shared library.
* Thu Jan 24 2002 hhetter@suse.de
- fixed filelist
* Wed Jan  9 2002 hhetter@suse.de
- updated to version 0.2.3
  * 24-bit audio processing bug fix for little-endian systems
  * new IRCAM file format support
  * new support for floating point data in AIFF-C and WAVE
  file format
  * improved support for compressed data in AIFF-C, WAVE and
  NeXT formats
  * code cleanup for 64-bit system
  * pkgconfig file for GNOME 2.0 platform compatibility
  * IMA and MS ADPCM format support
  * AF_QUERYTYPE_COMPRESSION support
- bz2 sources
* Sat Mar  3 2001 egger@suse.de
- Updated to version 0.2.1.
- Cleaned up specfile.
* Thu Nov  9 2000 ro@suse.de
- fixed obsoletes/provides
* Wed Nov  1 2000 egger@suse.de
- Updated specfile to new long packagenames.
- Reworked specfile.
- Probably needs some more work; I'm taking care of that.
* Tue Apr 25 2000 ro@suse.de
- fixed suse update config call
* Fri Apr  7 2000 bk@suse.de
- added suse update config marco
* Thu Sep 23 1999 ke@suse.de
- update: version 0.1.9.
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Thu Sep  9 1999 bs@suse.de
- fixed call of Check at the end of %%install section
* Mon Mar  1 1999 ke@suse.de
- update 0.1.6 (pre).
* Mon Feb 15 1999 ke@suse.de
- update (same version number...); from GNOME mirror.
* Sat Jan  9 1999 ke@suse.de
- initial package: version 0.1.5
